﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;
using System.Collections.Generic;
using UnityEngine.Networking.Types;
using System.Linq;

public class Line
{
	public Vector3 src { get; set; }

	public Vector3 dest { get; set; }

	public Vector3 ret { get; set; }

	public int ID { get; set; }
}

public class SphereScript : MonoBehaviour
{

	private Rigidbody rb;
	private LineRenderer lineRenderer;
	private List<Line> lines;
	private float vx;
	private float vy;

	void Start ()
	{
		vx = Random.Range (-0.002f, 0.002f);
		vy = Random.Range (-0.002f, 0.002f);
		rb = GetComponent<Rigidbody> ();
		lineRenderer = GetComponent<LineRenderer> ();
		lines = new List<Line> ();
	}

	void FixedUpdate ()
	{
		// X座標を動かす
		// 30で反転
		rb.AddForce (new Vector3 (vx, vy, 0f), ForceMode.VelocityChange);
		if (transform.position.x > 20 && vx > 0) {
			vx *= -1;
		} else if (transform.position.x < -20 && vx < 0) {
			vx *= -1;
		}
		if (transform.position.y > 20 && vy > 0) {
			vy *= -1;
		} else if (transform.position.y < -20 && vy < 0) {
			vy *= -1;
		}

	}

	void Update ()
	{
		_Draw ();
	}

	void _Draw ()
	{
		lineRenderer.SetVertexCount (lines.Count * 3);

		int position = 0;
		for (int i = 0; i < lines.Count; i++) {
			lineRenderer.SetPosition (position, lines [i].src);
			position++;
			lineRenderer.SetPosition (position, lines [i].dest);
			position++;
			lineRenderer.SetPosition (position, lines [i].ret);
			position++;
		}


	}

	void OnTriggerEnter (Collider other)
	{
	}

	private int count = 0;

	void OnTriggerStay (Collider other)
	{
		count++;
		if (count > 100) {
			if (other.gameObject.CompareTag ("SphereOrb")) {
				var item = lines.SingleOrDefault (i => i.ID == other.gameObject.GetInstanceID ());
				if (item == null) {
					Line l = new Line ();
					l.src = gameObject.transform.position;
					l.dest = other.gameObject.transform.position;
					l.ret = gameObject.transform.position;
					l.ID = gameObject.GetInstanceID ();
					lines.Add (l);
				} else {
					item.src = gameObject.transform.position;
					item.dest = other.gameObject.transform.position;
					item.ret = gameObject.transform.position;
					lineRenderer.SetVertexCount (0);
				}
			}
			count = 0;
		}
	}

	void OnTriggerExit (Collider other)
	{
		
		if (other.gameObject.CompareTag ("SphereOrb")) {
			var item = lines.SingleOrDefault (i => i.ID == other.gameObject.GetInstanceID ());
			if (item != null) {
				item.src = Vector3.zero;
				item.dest = Vector3.zero;
				item.ret = Vector3.zero;
			}

			lines.RemoveAll (i => i.ID == other.gameObject.GetInstanceID ());
		}
	}
}
